Bug 1017327 - Deployment descriptor per deployment
Deployment descriptor per deployment
Status: VERIFIED
Product: JBoss BPMS Platform 6
Classification: JBoss
Component: jBPM Core (Show other bugs)
6.0.0
Unspecified Unspecified
medium Severity low
: ER3
: 6.1.0
Assigned To: Maciej Swiderski
Marek Baluch
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-10-09 11:50 EDT by Kris Verlaenen
Modified: 2016-09-20 01:07 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: Feature Request
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Kris Verlaenen 2013-10-09 11:50:35 EDT
We should have some sort of deployment descriptors and the deployment service would make the plumbing based on that descriptor. So with that descriptor we could configure following:
- class loading, what besides the normal dependencies defined should be added to class loader of the project
- what persistence unit it shall use
- shall it use persistence at all (something that Jeff mentioned on early access list)
- logger - JPA, JMS, none
- strategy (singleton, per process instance, per request)
- work item handler configuration (and other session configurations)
- interceptors?
- might be more

Such a descriptor could be added:
 - to the kjar
 - related to a deployment (system repo?)
 - as default (where the defaults should be configurable themselves as well)
Comment 1 Kris Verlaenen 2013-10-09 11:51:39 EDT
Future feature
Comment 3 Prakash Aradhya 2013-10-17 13:46:41 EDT
Its the stuff that helps with system administration also.
JON like tool can take advantage of these descriptors.
Comment 4 Kris Verlaenen 2014-02-02 19:52:30 EST
One more could be initializing various types of listeners.

It would also be useful to make sure that these deployment descriptors, when part of the kjar, can be inherited (basically all deployment descriptors of dependent jars would be combined with the deployment descriptor of the jar itself, would need to be to detect / handle conflict though).
Comment 5 Eric D. Schabell 2014-02-14 05:59:28 EST
I think all the various grains of control are what you strive for:

- configure it per project
- configure it per deployment (then have a way for the project to select the deployment to run in)
- per server such as the default is always per_instance if not defined instead of SINGLETON as is now.

I guess the solutions offered in previous posts would all be possible and may be desirable depending on the above configuration needs:

- configure per project (in the kjar)
- configure per deployment (via UI, some xml file on server to override defaults)
- configure per server (same as deployments?)

If you use kjars and allow dependencies, what level wins? project or deployment or server overrides? 

Just my thoughts after playing with it a bit today.
Comment 6 Maciej Swiderski 2014-05-12 05:20:26 EDT
deployment descriptors have beed added to 6.1 code base, for those interested here are some docs about it: http://hudson.jboss.org/hudson/view/Drools%20jBPM/job/droolsjbpm-knowledge/lastSuccessfulBuild/artifact/kie-docs/jbpm-docs/target/docbook/publish/en-US/html/jBPMRuntimeManagement.html#d0e10446

feedback more than welcome
Comment 7 jbride@redhat.com 2014-05-12 08:05:38 EDT
very nice!!
Comment 8 Eric D. Schabell 2014-05-12 09:11:26 EDT
Excellent addition!
Comment 9 Marek Baluch 2014-12-15 07:56:39 EST
Verified on 6.1.0.ER3.

The feature is present.

Note You need to log in before you can comment on or make changes to this bug.